| Search Apache POI |

# Limitations

### Version 3.7 limitations

The intent of this document is to outline some of the known limitations of the POI HSSF API's. It is not intended to be complete list of every bug or missing feature of HSSF, rather it's purpose is to provide a broad feel for some of the functionality that is missing or broken.

- Charts
  You can not currently create charts. You can however create a chart in Excel, modify the chart data values using HSSF and write a new spreadsheet out. This is possible because POI attempts to keep existing records intact as far as possible.
- Macros
  Macros can not be created. However, reading and re-writing files containing macros will safely preserve the macros.
- Pivot Tables
  Generating pivot tables is not supported. It has been reported that files containing pivot tables can be read and re-written safely.

by Glen Stampoultzis